module Homework.Ch01 where

-- This calls reverse on toDigitsRev because I somehow did this backwards by default.
toDigits :: Integer -> [Integer]
toDigits = rev [] . toDigitsRev
  where
    rev acc (x : xs) = rev (x : acc) xs
    rev acc [] = acc

-- I don't know how I managed it, but turning the number into an array already reversed it?
toDigitsRev :: Integer -> [Integer]
toDigitsRev n
  | n < 1 = []
  | otherwise =
    let leftDigit = n `mod` 10
        shiftedDigits = n `div` 10
     in leftDigit : toDigitsRev shiftedDigits

doubleEveryOther :: [Integer] -> [Integer]
doubleEveryOther (odd' : even' : rest) = odd' : (even' * 2) : doubleEveryOther rest
doubleEveryOther rest = rest

sumDigits :: [Integer] -> Integer
sumDigits = sumDigits' 0 . flattenDigits [] . eachToDigits []
  where
    eachToDigits acc (x : xs) = eachToDigits (toDigits x : acc) xs
    eachToDigits acc [] = acc

    flattenDigits acc ((x : xs) : rest) = flattenDigits (x : acc) (xs : rest)
    flattenDigits acc ([] : rest) = flattenDigits acc rest
    flattenDigits acc [] = acc

    sumDigits' acc (x : xs) = sumDigits' (acc + x) xs
    sumDigits' acc [] = acc

validate :: Integer -> Bool
validate n = f n `mod` 10 == 0
  where
    f = sumDigits . doubleEveryOther . toDigitsRev
