module Homework.Ch01Spec where

import Homework.Ch01
import Test.Hspec

spec :: Spec
spec = describe "Credit Card Validation" $ do
  describe "toDigits" $ do
    context "n is less than 1" $ do
      it "returns an empty list" $ do
        toDigits 0 `shouldBe` []

    context "n contains a single digit" $ do
      it "creates a list with one digit" $ do
        toDigits 9 `shouldBe` [9]

    context "n contains more than one digit" $ do
      it "creates a list of digits" $ do
        toDigits 12345 `shouldBe` [1, 2, 3, 4, 5]

  describe "toDigitsRev" $ do
    context "n is less than 1" $ do
      it "returns an empty list" $ do
        toDigitsRev 0 `shouldBe` []

    context "n contains a single digit" $ do
      it "creates a list with one digit" $ do
        toDigitsRev 9 `shouldBe` [9]

    context "n contains more than one digit" $ do
      it "creates a list of the digits in reverse order" $ do
        toDigitsRev 12345 `shouldBe` [5, 4, 3, 2, 1]

  describe "doubleEveryOther" $ do
    context "list length is odd" $ do
      it "does not double the last digit" $ do
        doubleEveryOther [1, 2, 3, 4, 5] `shouldBe` [1, 4, 3, 8, 5]

    context "list length is even" $ do
      it "doubles every other digit" $ do
        doubleEveryOther [1, 2, 3, 4, 5, 6] `shouldBe` [1, 4, 3, 8, 5, 12]

  describe "sumDigits" $ do
    it "splits doubled digits into single digits and sums all single digits together" $ do
      sumDigits [16, 7, 12, 5] `shouldBe` 22

  describe "validate" $ do
    it "returns True for a valid credit card number" $ do
      validate 5105105105105100 `shouldBe` True
      validate 2223577120017656 `shouldBe` True
    it "returns False for invalid credit card number" $ do
      validate 5105105105105101 `shouldBe` False
      validate 2223573420017656 `shouldBe` False
